/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.Invoice;

import java.math.BigDecimal;
import java.sql.Timestamp;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record15;
import org.jooq.Row15;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceRecord extends UpdatableRecordImpl<InvoiceRecord> implements Record15<Integer, String, Integer, Timestamp, Timestamp, String, BigDecimal, Double, String, String, String, byte[], String, Timestamp, String> {

    private static final long serialVersionUID = 1925052954;

    /**
     * Setter for <code>INVOICE.ID_INVOICE</code>.
     */
    public void setIdInvoice(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>INVOICE.ID_INVOICE</code>.
     */
    public Integer getIdInvoice() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>INVOICE.INVOICE_CODE</code>.
     */
    public void setInvoiceCode(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>INVOICE.INVOICE_CODE</code>.
     */
    public String getInvoiceCode() {
        return (String) get(1);
    }

    /**
     * Setter for <code>INVOICE.CLIENT_ID</code>.
     */
    public void setClientId(Integer value) {
        set(2, value);
    }

    /**
     * Getter for <code>INVOICE.CLIENT_ID</code>.
     */
    public Integer getClientId() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>INVOICE.CREATION_DATE</code>.
     */
    public void setCreationDate(Timestamp value) {
        set(3, value);
    }

    /**
     * Getter for <code>INVOICE.CREATION_DATE</code>.
     */
    public Timestamp getCreationDate() {
        return (Timestamp) get(3);
    }

    /**
     * Setter for <code>INVOICE.LAST_UPDATE_DATE</code>.
     */
    public void setLastUpdateDate(Timestamp value) {
        set(4, value);
    }

    /**
     * Getter for <code>INVOICE.LAST_UPDATE_DATE</code>.
     */
    public Timestamp getLastUpdateDate() {
        return (Timestamp) get(4);
    }

    /**
     * Setter for <code>INVOICE.USER_ID</code>.
     */
    public void setUserId(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>INVOICE.USER_ID</code>.
     */
    public String getUserId() {
        return (String) get(5);
    }

    /**
     * Setter for <code>INVOICE.TOTAL_INVOICE</code>.
     */
    public void setTotalInvoice(BigDecimal value) {
        set(6, value);
    }

    /**
     * Getter for <code>INVOICE.TOTAL_INVOICE</code>.
     */
    public BigDecimal getTotalInvoice() {
        return (BigDecimal) get(6);
    }

    /**
     * Setter for <code>INVOICE.VAT</code>.
     */
    public void setVat(Double value) {
        set(7, value);
    }

    /**
     * Getter for <code>INVOICE.VAT</code>.
     */
    public Double getVat() {
        return (Double) get(7);
    }

    /**
     * Setter for <code>INVOICE.NOTE</code>.
     */
    public void setNote(String value) {
        set(8, value);
    }

    /**
     * Getter for <code>INVOICE.NOTE</code>.
     */
    public String getNote() {
        return (String) get(8);
    }

    /**
     * Setter for <code>INVOICE.STATUS</code>.
     */
    public void setStatus(String value) {
        set(9, value);
    }

    /**
     * Getter for <code>INVOICE.STATUS</code>.
     */
    public String getStatus() {
        return (String) get(9);
    }

    /**
     * Setter for <code>INVOICE.PDF_PATH</code>.
     */
    public void setPdfPath(String value) {
        set(10, value);
    }

    /**
     * Getter for <code>INVOICE.PDF_PATH</code>.
     */
    public String getPdfPath() {
        return (String) get(10);
    }

    /**
     * Setter for <code>INVOICE.PDF</code>.
     */
    public void setPdf(byte... value) {
        set(11, value);
    }

    /**
     * Getter for <code>INVOICE.PDF</code>.
     */
    public byte[] getPdf() {
        return (byte[]) get(11);
    }

    /**
     * Setter for <code>INVOICE.REQUEST_ID</code>.
     */
    public void setRequestId(String value) {
        set(12, value);
    }

    /**
     * Getter for <code>INVOICE.REQUEST_ID</code>.
     */
    public String getRequestId() {
        return (String) get(12);
    }

    /**
     * Setter for <code>INVOICE.DATE_OF_PERTINENCE</code>.
     */
    public void setDateOfPertinence(Timestamp value) {
        set(13, value);
    }

    /**
     * Getter for <code>INVOICE.DATE_OF_PERTINENCE</code>.
     */
    public Timestamp getDateOfPertinence() {
        return (Timestamp) get(13);
    }

    /**
     * Setter for <code>INVOICE.INVOICE_TYPE</code>. valori ammissibili: AUTOMATICA , ANTICIPO
     */
    public void setInvoiceType(String value) {
        set(14, value);
    }

    /**
     * Getter for <code>INVOICE.INVOICE_TYPE</code>. valori ammissibili: AUTOMATICA , ANTICIPO
     */
    public String getInvoiceType() {
        return (String) get(14);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record15 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row15<Integer, String, Integer, Timestamp, Timestamp, String, BigDecimal, Double, String, String, String, byte[], String, Timestamp, String> fieldsRow() {
        return (Row15) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row15<Integer, String, Integer, Timestamp, Timestamp, String, BigDecimal, Double, String, String, String, byte[], String, Timestamp, String> valuesRow() {
        return (Row15) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Invoice.INVOICE.ID_INVOICE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Invoice.INVOICE.INVOICE_CODE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field3() {
        return Invoice.INVOICE.CLIENT_ID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Timestamp> field4() {
        return Invoice.INVOICE.CREATION_DATE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Timestamp> field5() {
        return Invoice.INVOICE.LAST_UPDATE_DATE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field6() {
        return Invoice.INVOICE.USER_ID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field7() {
        return Invoice.INVOICE.TOTAL_INVOICE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Double> field8() {
        return Invoice.INVOICE.VAT;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field9() {
        return Invoice.INVOICE.NOTE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field10() {
        return Invoice.INVOICE.STATUS;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field11() {
        return Invoice.INVOICE.PDF_PATH;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<byte[]> field12() {
        return Invoice.INVOICE.PDF;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field13() {
        return Invoice.INVOICE.REQUEST_ID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Timestamp> field14() {
        return Invoice.INVOICE.DATE_OF_PERTINENCE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field15() {
        return Invoice.INVOICE.INVOICE_TYPE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getInvoiceCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component3() {
        return getClientId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp component4() {
        return getCreationDate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp component5() {
        return getLastUpdateDate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component6() {
        return getUserId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component7() {
        return getTotalInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Double component8() {
        return getVat();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component9() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component10() {
        return getStatus();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component11() {
        return getPdfPath();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public byte[] component12() {
        return getPdf();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component13() {
        return getRequestId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp component14() {
        return getDateOfPertinence();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component15() {
        return getInvoiceType();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getInvoiceCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value3() {
        return getClientId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp value4() {
        return getCreationDate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp value5() {
        return getLastUpdateDate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value6() {
        return getUserId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value7() {
        return getTotalInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Double value8() {
        return getVat();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value9() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value10() {
        return getStatus();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value11() {
        return getPdfPath();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public byte[] value12() {
        return getPdf();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value13() {
        return getRequestId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Timestamp value14() {
        return getDateOfPertinence();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value15() {
        return getInvoiceType();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value1(Integer value) {
        setIdInvoice(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value2(String value) {
        setInvoiceCode(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value3(Integer value) {
        setClientId(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value4(Timestamp value) {
        setCreationDate(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value5(Timestamp value) {
        setLastUpdateDate(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value6(String value) {
        setUserId(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value7(BigDecimal value) {
        setTotalInvoice(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value8(Double value) {
        setVat(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value9(String value) {
        setNote(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value10(String value) {
        setStatus(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value11(String value) {
        setPdfPath(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value12(byte... value) {
        setPdf(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value13(String value) {
        setRequestId(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value14(Timestamp value) {
        setDateOfPertinence(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord value15(String value) {
        setInvoiceType(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceRecord values(Integer value1, String value2, Integer value3, Timestamp value4, Timestamp value5, String value6, BigDecimal value7, Double value8, String value9, String value10, String value11, byte[] value12, String value13, Timestamp value14, String value15) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        value9(value9);
        value10(value10);
        value11(value11);
        value12(value12);
        value13(value13);
        value14(value14);
        value15(value15);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached InvoiceRecord
     */
    public InvoiceRecord() {
        super(Invoice.INVOICE);
    }

    /**
     * Create a detached, initialised InvoiceRecord
     */
    public InvoiceRecord(Integer idInvoice, String invoiceCode, Integer clientId, Timestamp creationDate, Timestamp lastUpdateDate, String userId, BigDecimal totalInvoice, Double vat, String note, String status, String pdfPath, byte[] pdf, String requestId, Timestamp dateOfPertinence, String invoiceType) {
        super(Invoice.INVOICE);

        set(0, idInvoice);
        set(1, invoiceCode);
        set(2, clientId);
        set(3, creationDate);
        set(4, lastUpdateDate);
        set(5, userId);
        set(6, totalInvoice);
        set(7, vat);
        set(8, note);
        set(9, status);
        set(10, pdfPath);
        set(11, pdf);
        set(12, requestId);
        set(13, dateOfPertinence);
        set(14, invoiceType);
    }
}
